Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/NewHiveService.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/NewHiveService.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/NewHiveService.cs	(revision 12691)
@@ -420,37 +733,147 @@
 
     public IEnumerable<Slave> GetSlaves() {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      bool isAdministrator = RoleVerifier.IsInRole(HiveRoles.Administrator);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("GetSlaves")) {
+        var slaveDao = pm.SlaveDao;
+        var resourcePermissionDao = pm.ResourcePermissionDao;
+        var currentUserId = UserManager.CurrentUserId;
+        return pm.UseTransaction(() => {
+          var resourcePermissions = resourcePermissionDao.GetAll();
+          return slaveDao.GetAll()
+            .Where(x => isAdministrator
+              || x.OwnerUserId == null
+              || x.OwnerUserId == currentUserId
+              || UserManager.VerifyUser(currentUserId, resourcePermissions
+                  .Where(y => y.ResourceId == x.ResourceId)
+                  .Select(z => z.GrantedUserId)
+                  .ToList())
+              )
+            .Select(x => x.ToDto())
+            .ToList();
+        });
+      }
     }
 
     public IEnumerable<SlaveGroup> GetSlaveGroups() {
-      throw new NotImplementedException();
-    }
-
-    public void UpdateSlave(Slave slave) {
-      throw new NotImplementedException();
-    }
-
-    public void UpdateSlaveGroup(SlaveGroup slaveGroup) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      bool isAdministrator = RoleVerifier.IsInRole(HiveRoles.Administrator);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("GetSlaveGroups")) {
+        var slaveGroupDao = pm.SlaveGroupDao;
+        var resourcePermissionDao = pm.ResourcePermissionDao;
+        var currentUserId = UserManager.CurrentUserId;
+        return pm.UseTransaction(() => {
+          var resourcePermissions = resourcePermissionDao.GetAll();
+          return slaveGroupDao.GetAll()
+            .Where(x => isAdministrator
+              || x.OwnerUserId == null
+              || x.OwnerUserId == currentUserId
+              || UserManager.VerifyUser(currentUserId, resourcePermissions
+                  .Where(y => y.ResourceId == x.ResourceId)
+                  .Select(z => z.GrantedUserId)
+                  .ToList())
+              )
+            .Select(x => x.ToDto())
+            .ToList();
+        });
+      }
+    }
+
+    public void UpdateSlave(DT.Slave slaveDto) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("UpdateSlave")) {
+        var slaveDao = pm.SlaveDao;
+        pm.UseTransaction(() => {
+          var slave = slaveDao.GetById(slaveDto.Id);
+          if (slave != null) {
+            slaveDto.CopyToEntity(slave);
+          } else {
+            slaveDao.Save(slaveDto.ToEntity());
+          }
+          pm.SubmitChanges();
+        });
+      }
+    }
+
+    public void UpdateSlaveGroup(DT.SlaveGroup slaveGroupDto) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("UpdateSlaveGroup")) {
+        var slaveGroupDao = pm.SlaveGroupDao;
+        pm.UseTransaction(() => {
+          var slaveGroup = slaveGroupDao.GetById(slaveGroupDto.Id);
+          if (slaveGroup != null) {
+            slaveGroupDto.CopyToEntity(slaveGroup);
+          } else {
+            slaveGroupDao.Save(slaveGroupDto.ToEntity());
+          }
+          pm.SubmitChanges();
+        });
+      }
     }
 
     public void DeleteSlave(Guid slaveId) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      AuthorizationManager.AuthorizeForResourceAdministration(slaveId);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("DeleteSlave")) {
+        var slaveDao = pm.SlaveDao;
+        pm.UseTransaction(() => {
+          slaveDao.Delete(slaveId);
+        });
+      }
     }
 
     public void DeleteSlaveGroup(Guid slaveGroupId) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      AuthorizationManager.AuthorizeForResourceAdministration(slaveGroupId);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("DeleteSlaveGroup")) {
+        var slaveGroupDao = pm.SlaveGroupDao;
+        pm.UseTransaction(() => {
+          slaveGroupDao.Delete(slaveGroupId);
+        });
+      }
     }
 
     public void AddResourceToGroup(Guid slaveGroupId, Guid resourceId) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("AddResourceToGroup")) {
+        var resourceDao = pm.ResourceDao;
+        pm.UseTransaction(() => {
+          var resource = resourceDao.GetById(resourceId);
+          resource.ParentResourceId = slaveGroupId;
+          pm.SubmitChanges();
+        });
+      }
     }
 
     public void RemoveResourceFromGroup(Guid slaveGroupId, Guid resourceId) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("RemoveResourceFromGroup")) {
+        var resourceDao = pm.ResourceDao;
+        pm.UseTransaction(() => {
+          var resource = resourceDao.GetById(resourceId);
+          resource.ParentResourceId = null;
+          pm.SubmitChanges();
+        });
+      }
     }
 
     public Guid GetResourceId(string resourceName) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("GetResourceId")) {
+        var resourceDao = pm.ResourceDao;
+        return pm.UseTransaction(() => {
+          var resource = resourceDao.GetByName(resourceName);
+          return resource != null ? resource.ResourceId : Guid.Empty;
+        });
+      }
     }
 
@@ -461,40 +884,128 @@
 
     public void TriggerEventManager(bool force) {
-      // private method...
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Slave);
+      // use a serializable transaction here to ensure not two threads execute this simultaniously (mutex-lock would not work since IIS may use multiple AppDomains)
+      bool cleanup;
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("TriggerEventManager")) {
+        cleanup = false;
+        var lifecycleDao = pm.LifecycleDao;
+        pm.UseTransaction(() => {
+          var lastLifecycle = lifecycleDao.GetLastLifecycle();
+          DateTime lastCleanup = lastLifecycle != null ? lastLifecycle.LastCleanup : DateTime.MinValue;
+          if (force || DateTime.Now - lastCleanup > HeuristicLab.Services.Hive.Properties.Settings.Default.CleanupInterval) {
+            lifecycleDao.UpdateLifecycle();
+            cleanup = true;
+            pm.SubmitChanges();
+          }
+        }, true);
+      }
+      if (cleanup) {
+        EventManager.Cleanup();
+      }
     }
 
     public int GetNewHeartbeatInterval(Guid slaveId) {
-      throw new NotImplementedException();
-    }
-
-    public Guid AddDowntime(Downtime downtime) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Slave);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("GetNewHeartbeatInterval")) {
+        var slaveDao = pm.SlaveDao;
+        return pm.UseTransaction(() => {
+          var slave = slaveDao.GetById(slaveId);
+          if (slave != null) {
+            return slave.HbInterval;
+          }
+          return -1;
+        });
+      }
+    }
+    #endregion
+
+    #region Downtime Methods
+    public Guid AddDowntime(DT.Downtime downtimeDto) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      AuthorizationManager.AuthorizeForResourceAdministration(downtimeDto.ResourceId);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("AddDowntime")) {
+        var downtimeDao = pm.DowntimeDao;
+        return pm.UseTransaction(() => {
+          var downtime = downtimeDao.Save(downtimeDto.ToEntity());
+          pm.SubmitChanges();
+          return downtime.ResourceId;
+        });
+      }
     }
 
     public void DeleteDowntime(Guid downtimeId) {
-      throw new NotImplementedException();
-    }
-
-    public void UpdateDowntime(Downtime downtime) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("DeleteDowntime")) {
+        var downtimeDao = pm.DowntimeDao;
+        pm.UseTransaction(() => {
+          downtimeDao.Delete(downtimeId);
+          pm.SubmitChanges();
+        });
+      }
+    }
+
+    public void UpdateDowntime(DT.Downtime downtimeDto) {
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      AuthorizationManager.AuthorizeForResourceAdministration(downtimeDto.ResourceId);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("UpdateDowntime")) {
+        var downtimeDao = pm.DowntimeDao;
+        pm.UseTransaction(() => {
+          var downtime = downtimeDao.GetById(downtimeDto.Id);
+          if (downtime != null) {
+            downtimeDto.CopyToEntity(downtime);
+          } else {
+            downtimeDao.Save(downtimeDto.ToEntity());
+          }
+          pm.SubmitChanges();
+        });
+      }
     }
 
     public IEnumerable<Downtime> GetDowntimesForResource(Guid resourceId) {
-      throw new NotImplementedException();
-    }
-
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("GetDowntimesForResource")) {
+        var downtimeDao = pm.DowntimeDao;
+        return pm.UseTransaction(() => downtimeDao.GetByResourceId(resourceId)
+          .Select(x => x.ToDto())
+          .ToList()
+        );
+      }
+    }
+    #endregion
+
+    #region User Methods
     public string GetUsernameByUserId(Guid userId) {
-      throw new NotImplementedException();
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      var user = UserManager.GetUserById(userId);
+      return user != null ? user.UserName : null;
     }
 
     public Guid GetUserIdByUsername(string username) {
-      throw new NotImplementedException();
-    }
-
+      RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      var user = ServiceLocator.Instance.UserManager.GetUserByName(username);
+      return user != null ? (Guid?)user.ProviderUserKey ?? Guid.Empty : Guid.Empty;
+    }
+    #endregion
+
+    #region UserPriorities Methods
     public IEnumerable<UserPriority> GetUserPriorities() {
-      throw new NotImplementedException();
-    }
-
+      using (var pm = PersistenceManager)
+      using (new PerformanceLogger("GetUserPriorities")) {
+        var userPriorityDao = pm.UserPriorityDao;
+        return pm.UseTransaction(() => userPriorityDao.GetAll()
+          .Select(x => x.ToDto())
+          .ToList()
+        );
+      }
+    }
+    #endregion
+
+    #region Statistics Methods
     public IEnumerable<Statistics> GetStatistics() {
       // unused
@@ -506,4 +1017,46 @@
       throw new NotImplementedException();
     }
+    #endregion
+
+    #region Private Helper Methods
+    private void UpdateTaskState(IPersistenceManager pm, DA.Task task, DT.TaskState taskState, Guid? slaveId, Guid? userId, string exception) {
+      var stateLogDao = pm.StateLogDao;
+      var taskStateEntity = taskState.ToEntity();
+      if (task.Command == DA.Command.Pause && task.State == DA.TaskState.Paused
+          || task.Command == DA.Command.Abort && task.State == DA.TaskState.Aborted
+          || task.Command == DA.Command.Stop && task.State == DA.TaskState.Aborted) {
+        task.Command = null;
+      } else if (taskStateEntity == DA.TaskState.Paused && task.Command != null) {
+        taskStateEntity = DA.TaskState.Waiting;
+      }
+      stateLogDao.Save(new DA.StateLog {
+        State = taskStateEntity,
+        DateTime = DateTime.Now,
+        TaskId = task.TaskId,
+        UserId = userId,
+        SlaveId = slaveId,
+        Exception = exception
+      });
+      task.State = taskStateEntity;
+    }
+
+    private DA.Resource AuthorizeForResource(IPersistenceManager pm, Guid resourceId) {
+      var resourceDao = pm.ResourceDao;
+      var resource = resourceDao.GetById(resourceId);
+      if (resource == null) throw new SecurityException("Not authorized");
+      if (resource.OwnerUserId != UserManager.CurrentUserId
+          && !RoleVerifier.IsInRole(HiveRoles.Administrator)) {
+        throw new SecurityException("Not authorized");
+      }
+      return resource;
+    }
+
+    [MethodImpl(MethodImplOptions.NoInlining)]
+    public string GetCurrentMethod() {
+      StackTrace st = new StackTrace();
+      StackFrame sf = st.GetFrame(1);
+      return sf.GetMethod().Name;
+    }
+    #endregion
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/PerformanceLogger.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/PerformanceLogger.cs	(revision 12691)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/PerformanceLogger.cs	(revision 12691)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Diagnostics;
+using HeuristicLab.Services.Hive.DataAccess;
+
+namespace HeuristicLab.Services.Hive {
+  public class PerformanceLogger : IDisposable {
+
+    private readonly Stopwatch stopwatch;
+    private string name;
+
+    public PerformanceLogger(string name) {
+      this.name = name;
+      stopwatch = new Stopwatch();
+      stopwatch.Start();
+    }
+    public void Dispose() {
+      stopwatch.Stop();
+      LogFactory.GetLogger(this.GetType().Namespace).Log(string.Format("{0} took {1}ms", name, stopwatch.ElapsedMilliseconds));
+    }
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Scheduler/NewRoundRobinTaskScheduler.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Scheduler/NewRoundRobinTaskScheduler.cs	(revision 12691)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Scheduler/NewRoundRobinTaskScheduler.cs	(revision 12691)
@@ -0,0 +1,105 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DA = HeuristicLab.Services.Hive.DataAccess;
+
+namespace HeuristicLab.Services.Hive {
+  public class NewRoundRobinTaskScheduler : ITaskScheduler {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public IEnumerable<TaskInfoForScheduler> Schedule(IEnumerable<TaskInfoForScheduler> tasks, int count = 1) {
+      if (!tasks.Any()) return Enumerable.Empty<TaskInfoForScheduler>();
+
+      using (var pm = PersistenceManager) {
+        var userPriorityDao = pm.UserPriorityDao;
+        var jobDao = pm.JobDao;
+
+        var userPriorities = pm.UseTransaction(() => userPriorityDao.GetAll()
+          .OrderBy(x => x.DateEnqueued)
+          .ToArray()
+        );
+
+        var userIds = userPriorities.Select(x => x.UserId).ToList();
+        var jobs = pm.UseTransaction(() => {
+          return jobDao.GetAll()
+            .Where(x => userIds.Contains(x.OwnerUserId))
+            .Select(x => new {
+              Id = x.JobId,
+              DateCreated = x.DateCreated,
+              OwnerUserId = x.OwnerUserId
+            })
+            .ToList();
+        });
+
+        var taskJobRelations = tasks.Join(jobs,
+          task => task.JobId,
+          job => job.Id,
+          (task, job) => new { Task = task, JobInfo = job })
+          .OrderByDescending(x => x.Task.Priority)
+          .ToList();
+
+        var scheduledTasks = new List<TaskInfoForScheduler>();
+        int priorityIndex = 0;
+
+        if (count == 0 || count > taskJobRelations.Count) count = taskJobRelations.Count;
+
+        for (int i = 0; i < count; i++) {
+          var defaultEntry = taskJobRelations.First(); // search first task which is not included yet
+          var priorityEntries = taskJobRelations.Where(x => x.JobInfo.OwnerUserId == userPriorities[priorityIndex].UserId).ToArray(); // search for tasks with desired user priority
+          while (!priorityEntries.Any() && priorityIndex < userPriorities.Length - 1) {
+            priorityIndex++;
+            priorityEntries = taskJobRelations.Where(x => x.JobInfo.OwnerUserId == userPriorities[priorityIndex].UserId).ToArray();
+          }
+          if (priorityEntries.Any()) { // tasks with desired user priority found
+            var priorityEntry = priorityEntries.OrderByDescending(x => x.Task.Priority).ThenBy(x => x.JobInfo.DateCreated).First();
+            if (defaultEntry.Task.Priority <= priorityEntry.Task.Priority) {
+              taskJobRelations.Remove(priorityEntry);
+              scheduledTasks.Add(priorityEntry.Task);
+              UpdateUserPriority(pm, userPriorities[priorityIndex]);
+              priorityIndex++;
+            } else { // there are other tasks with higher priorities
+              taskJobRelations.Remove(defaultEntry);
+              scheduledTasks.Add(defaultEntry.Task);
+            }
+          } else {
+            taskJobRelations.Remove(defaultEntry);
+            scheduledTasks.Add(defaultEntry.Task);
+          }
+          if (priorityIndex >= (userPriorities.Length - 1)) priorityIndex = 0;
+        }
+        return scheduledTasks;
+      }
+    }
+
+    private void UpdateUserPriority(IPersistenceManager pm, DA.UserPriority up) {
+      pm.UseTransaction(() => {
+        up.DateEnqueued = DateTime.Now;
+        pm.SubmitChanges();
+      });
+    }
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 12691)
@@ -23,4 +23,5 @@
 using HeuristicLab.Services.Hive.DataAccess.Interfaces;
 using HeuristicLab.Services.Hive.DataAccess.Manager;
+using HeuristicLab.Services.Hive.Manager;
 
 namespace HeuristicLab.Services.Hive {
@@ -37,5 +38,10 @@
 
     public IPersistenceManager PersistenceManager {
-      get { return new PersistenceManager(); }
+      get {
+        var dataContext = HiveOperationContext.Current != null
+                            ? HiveOperationContext.Current.DataContext
+                            : new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
+        return new PersistenceManager(dataContext);
+      }
     }
 
@@ -102,4 +108,12 @@
     }
 
+    private NewHeartbeatManager newheartbeatManager;
+    public NewHeartbeatManager NewHeartbeatManager {
+      get {
+        if (newheartbeatManager == null) newheartbeatManager = new NewHeartbeatManager();
+        return newheartbeatManager;
+      }
+    }
+
     private HeartbeatManager heartbeatManager;
     public HeartbeatManager HeartbeatManager {
@@ -117,4 +131,11 @@
       }
     }
+    private ITaskScheduler newtaskScheduler;
+    public ITaskScheduler NewTaskScheduler {
+      get {
+        if (newtaskScheduler == null) newtaskScheduler = new RoundRobinTaskScheduler();
+        return newtaskScheduler;
+      }
+    }
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApi/DataController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApi/DataController.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApi/DataController.cs	(revision 12691)
@@ -85,9 +85,9 @@
           }).FirstOrDefault();
         var calculatingTasks = factTasks.Where(x => x.TaskState == TaskState.Calculating);
-        int count = calculatingTasks.Count();
+        int count = calculatingTasks.Count() / 3;
         return new DT.TimeStatus {
           MinCalculatingTime = lastCalculatingTimes != null ? lastCalculatingTimes.Min : 0,
           MaxCalculatingTime = lastCalculatingTimes != null ? lastCalculatingTimes.Max : 0,
-          AvgWaitingTime = count > 0 ? (long)calculatingTasks.OrderBy(x => x.StartTime).Take(count / 3).Average(x => x.InitialWaitingTime) : 0,
+          AvgWaitingTime = count > 0 ? (long)calculatingTasks.OrderBy(x => x.StartTime).Take(count).Average(x => x.InitialWaitingTime) : 0,
           AvgCalculatingTime = lastCalculatingTimes != null ? lastCalculatingTimes.Avg : 0,
           TotalCpuTime = factTasks.Sum(x => x.CalculatingTime),
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml	(revision 12691)
@@ -33,5 +33,6 @@
             <div class="btn-group" dropdown dropdown-append-to-body>
                 <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 130px; text-align: left;">
-                    {{curQuickSelection.name}} <span class="glyphicon glyphicon-chevron-down" style="margin-top: 3px; float:right"></span>
+                    <span class="text-left" style="display: inline-block; width: 85px;">{{curQuickSelection.name}}</span>
+                    <span class="glyphicon glyphicon-chevron-down" style="margin-top: 3px;"></span>
                 </button>
                 <ul class="dropdown-menu" role="menu">
